summaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
Diffstat (limited to 'tests')
-rw-r--r--tests/Makefile.am1
-rwxr-xr-xtests/ls/abmon-align51
2 files changed, 52 insertions, 0 deletions
diff --git a/tests/Makefile.am b/tests/Makefile.am
index 2e2a5f06f..07f34ec45 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -331,6 +331,7 @@ TESTS = \
ln/misc \
ln/sf-1 \
ln/target-1 \
+ ls/abmon-align \
ls/color-clear-to-eol \
ls/color-dtype-dir \
ls/dangle \
diff --git a/tests/ls/abmon-align b/tests/ls/abmon-align
new file mode 100755
index 000000000..73b51e8a2
--- /dev/null
+++ b/tests/ls/abmon-align
@@ -0,0 +1,51 @@
+#!/bin/sh
+# Ensure ls output is aligned when using abbreviated months from the locale
+
+# Copyright (C) 2009 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ ls --version
+fi
+
+. $srcdir/test-lib.sh
+
+for mon in $(seq -w 12); do
+ touch -d"+$mon month" $mon.ts || framework_failure
+done
+
+fail=0
+
+# Note some of the following locales may be missing but if so
+# we should fail back to the C locale which should be aligned
+
+for format in "%b" "[%b" "%b]" "[%b]"; do
+ for LOC in C gv_GB ga_IE fi_FI.utf8 zh_CN ar_SY $LOCALE_FR_UTF8; do
+ n_widths=$(
+ LC_ALL=$LOC TIME_STYLE=+"$format" ls -lgG *.ts |
+ LC_ALL=C sed '1d; s/.\{15\}\(.*\) ...ts$/\1/; s/ /./g' |
+ while read mon; do echo "$mon" | LC_ALL=$LOC wc -L; done |
+ uniq | wc -l
+ )
+ test "$n_widths" = "1" || { fail=1; break 2; }
+ done
+done
+if test "$fail" = "1"; then
+ echo "misalignment detected in $LOC locale:"
+ LC_ALL=$LOC TIME_STYLE=+%b ls -lgG *.ts
+fi
+
+Exit $fail